diff -uNrp a/panels/region/cinnamon-region-panel.ui b/panels/region/cinnamon-region-panel.ui
--- a/panels/region/cinnamon-region-panel.ui	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cinnamon-region-panel.ui	2013-09-21 13:24:15.347949247 +0100
@@ -162,27 +162,17 @@
                             <style>
                               <class name="inline-toolbar"/>
                             </style>
+                            <style>
+                              <class name="inline-toolbar"/>
+                            </style>
                             <child>
                               <object class="GtkToolButton" id="language_add">
+                                <property name="use_action_appearance">False</property>
                                 <property name="visible">True</property>
-                                <property name="can_focus">False</property>
                                 <property name="label" translatable="yes">Add Language</property>
-                                <property name="use_underline">True</property>
-                                <property name="icon_name">list-add-symbolic</property>
-                              </object>
-                              <packing>
-                                <property name="expand">False</property>
-                                <property name="homogeneous">True</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkToolButton" id="language_remove">
-                                <property name="visible">True</property>
-                                <property name="sensitive">False</property>
                                 <property name="can_focus">False</property>
-                                <property name="label" translatable="yes">Remove Language</property>
                                 <property name="use_underline">True</property>
-                                <property name="icon_name">list-remove-symbolic</property>
+                                <property name="icon_name">list-add-symbolic</property>
                               </object>
                               <packing>
                                 <property name="expand">False</property>
@@ -198,12 +188,13 @@
                         </child>
                         <child>
                           <object class="GtkVBox" id="vbox3">
-                            <property name="visible">True</property>
                             <property name="can_focus">False</property>
                             <child>
                               <object class="GtkLabel" id="label23">
                                 <property name="visible">True</property>
                                 <property name="can_focus">False</property>
+                                <property name="use_underline">True</property>
+                                <property name="label" translatable="yes">Add Language</property>
                               </object>
                               <packing>
                                 <property name="expand">True</property>
@@ -212,23 +203,24 @@
                               </packing>
                             </child>
                             <child>
-                              <object class="GtkButton" id="get_languages_button">
-                                <property name="label" translatable="yes">button</property>
+                              <object class="GtkLinkButton" id="linkbutton1">
+                                <property name="label" translatable="yes">Install languages...</property>
                                 <property name="visible">True</property>
                                 <property name="can_focus">True</property>
                                 <property name="receives_default">True</property>
+                                <property name="has_tooltip">True</property>
                               </object>
                               <packing>
-                                <property name="expand">True</property>
+                                <property name="expand">False</property>
                                 <property name="fill">True</property>
-                                <property name="position">13</property>
+                                <property name="position">1</property>
                               </packing>
                             </child>
                           </object>
                           <packing>
                             <property name="expand">False</property>
                             <property name="fill">True</property>
-                            <property name="position">2</property>
+                            <property name="position">1</property>
                           </packing>
                         </child>
                       </object>
@@ -305,19 +297,19 @@
                         </child>
                         <child>
                           <object class="GtkToolbar" id="region-toolbar">
-                            <property name="visible">True</property>
-                            <property name="can_focus">False</property>
                             <property name="toolbar_style">icons</property>
                             <property name="show_arrow">False</property>
                             <property name="icon_size">1</property>
+                            <property name="visible">True</property>
                             <style>
                               <class name="inline-toolbar"/>
                             </style>
                             <child>
                               <object class="GtkToolButton" id="region_add">
+                                <property name="use_action_appearance">False</property>
+                                <property name="label" translatable="yes">Add Region</property>
                                 <property name="visible">True</property>
                                 <property name="can_focus">False</property>
-                                <property name="label" translatable="yes">Add Region</property>
                                 <property name="use_underline">True</property>
                                 <property name="icon_name">list-add-symbolic</property>
                               </object>
@@ -328,10 +320,11 @@
                             </child>
                             <child>
                               <object class="GtkToolButton" id="region_remove">
+                                <property name="use_action_appearance">False</property>
                                 <property name="visible">True</property>
+                                <property name="label" translatable="yes">Remove Region</property>
                                 <property name="sensitive">False</property>
                                 <property name="can_focus">False</property>
-                                <property name="label" translatable="yes">Remove Region</property>
                                 <property name="use_underline">True</property>
                                 <property name="icon_name">list-remove-symbolic</property>
                               </object>
@@ -373,18 +366,6 @@
                                 <property name="n_rows">9</property>
                                 <property name="n_columns">2</property>
                                 <child>
-                                  <placeholder/>
-                                </child>
-                                <child>
-                                  <placeholder/>
-                                </child>
-                                <child>
-                                  <placeholder/>
-                                </child>
-                                <child>
-                                  <placeholder/>
-                                </child>
-                                <child>
                                   <object class="GtkLabel" id="label7">
                                     <property name="visible">True</property>
                                     <property name="can_focus">False</property>
@@ -626,6 +607,12 @@
                         <property name="height">1</property>
                       </packing>
                     </child>
+                    <child>
+                      <placeholder/>
+                    </child>
+                    <child>
+                      <placeholder/>
+                    </child>
                   </object>
                   <packing>
                     <property name="position">1</property>
@@ -643,36 +630,43 @@
                   </packing>
                 </child>
                 <child>
-                  <object class="GtkVBox" id="vbox1">
+                  <object class="GtkVBox" id="vbox5">
                     <property name="visible">True</property>
                     <property name="can_focus">False</property>
-                    <property name="border_width">10</property>
+                    <property name="border_width">12</property>
                     <property name="spacing">12</property>
                     <child>
-                      <placeholder/>
+                      <object class="GtkLabel" id="label24">
+                        <property name="visible">True</property>
+                        <property name="can_focus">False</property>
+                        <property name="xalign">0</property>
+                        <property name="label" translatable="yes">Select keyboards or other input sources</property>
+                      </object>
+                      <packing>
+                        <property name="expand">False</property>
+                        <property name="fill">False</property>
+                        <property name="position">0</property>
+                      </packing>
                     </child>
                     <child>
-                      <object class="GtkHBox" id="hbox2">
+                      <object class="GtkHBox" id="hbox3">
                         <property name="visible">True</property>
                         <property name="can_focus">False</property>
                         <property name="spacing">12</property>
                         <child>
-                          <object class="GtkVBox" id="vbox7">
+                          <object class="GtkVBox" id="vbox6">
                             <property name="visible">True</property>
                             <property name="can_focus">False</property>
                             <child>
-                              <object class="GtkScrolledWindow" id="xkb_layouts_swindow">
+                              <object class="GtkScrolledWindow" id="input_sources_swindow">
                                 <property name="visible">True</property>
                                 <property name="can_focus">True</property>
                                 <property name="shadow_type">in</property>
                                 <child>
-                                  <object class="GtkTreeView" id="xkb_layouts_selected">
+                                  <object class="GtkTreeView" id="active_input_sources">
                                     <property name="visible">True</property>
                                     <property name="can_focus">True</property>
                                     <property name="headers_visible">False</property>
-                                    <child internal-child="selection">
-                                      <object class="GtkTreeSelection" id="treeview-selection1"/>
-                                    </child>
                                   </object>
                                 </child>
                               </object>
@@ -683,7 +677,7 @@
                               </packing>
                             </child>
                             <child>
-                              <object class="GtkToolbar" id="layouts-toolbar">
+                              <object class="GtkToolbar" id="input-toolbar">
                                 <property name="visible">True</property>
                                 <property name="can_focus">False</property>
                                 <property name="toolbar_style">icons</property>
@@ -693,70 +687,166 @@
                                   <class name="inline-toolbar"/>
                                 </style>
                                 <child>
-                                  <object class="GtkToolButton" id="xkb_layouts_add">
+                                  <object class="GtkToolItem" id="i_s_ar_item">
                                     <property name="visible">True</property>
-                                    <property name="can_focus">False</property>
-                                    <property name="label" translatable="yes">Add Layout</property>
-                                    <property name="use_underline">True</property>
-                                    <property name="icon_name">list-add-symbolic</property>
+                                    <child>
+                                      <object class="GtkBox" id="i_s_ar_box">
+                                        <property name="visible">True</property>
+                                        <child>
+                                           <object class="GtkButton" id="input_source_add">
+                                             <property name="visible">True</property>
+                                             <child internal-child="accessible">
+                                               <object class="AtkObject" id="i_s_a_a11y">
+                                                 <property name="accessible-name" translatable="yes">Add Input Source</property>
+                                               </object>
+                                             </child>
+                                             <child>
+                                                <object class="GtkImage" id="i_s_a_image">
+
+                                                  <property name="visible">True</property>
+                                                  <property name="icon-name">list-add-symbolic</property>
+                                                  <property name="icon-size">1</property>
+                                                </object>
+                                             </child>
+                                           </object>
+                                        </child>
+                                        <child>
+                                           <object class="GtkButton" id="input_source_remove">
+                                             <property name="visible">True</property>
+                                             <child internal-child="accessible">
+                                               <object class="AtkObject" id="i_s_r_a11y">
+                                                 <property name="accessible-name" translatable="yes">Remove Input Source</property>
+                                               </object>
+                                             </child>
+                                             <child>
+                                                <object class="GtkImage" id="i_s_r_image">
+                                                  <property name="visible">True</property>
+                                                  <property name="icon-name">list-remove-symbolic</property>
+                                                  <property name="icon-size">1</property>
+                                                </object>
+                                             </child>
+                                           </object>
+                                        </child>
+                                      </object>
+                                    </child>
                                   </object>
-                                  <packing>
-                                    <property name="expand">False</property>
-                                    <property name="homogeneous">True</property>
-                                  </packing>
                                 </child>
+
                                 <child>
-                                  <object class="GtkToolButton" id="xkb_layouts_remove">
+                                  <object class="GtkSeparatorToolItem" id="sep1">
                                     <property name="visible">True</property>
-                                    <property name="can_focus">False</property>
-                                    <property name="label" translatable="yes">Remove Layout</property>
-                                    <property name="use_underline">True</property>
-                                    <property name="icon_name">list-remove-symbolic</property>
+                                    <property name="draw">False</property>
                                   </object>
                                   <packing>
-                                    <property name="expand">False</property>
-                                    <property name="homogeneous">True</property>
+                                    <property name="expand">True</property>
                                   </packing>
                                 </child>
+
                                 <child>
-                                  <object class="GtkToolButton" id="xkb_layouts_move_up">
+                                  <object class="GtkToolItem" id="i_s_ud_item">
                                     <property name="visible">True</property>
-                                    <property name="can_focus">False</property>
-                                    <property name="label" translatable="yes">Move Up</property>
-                                    <property name="use_underline">True</property>
-                                    <property name="icon_name">go-up-symbolic</property>
+                                    <child>
+                                      <object class="GtkBox" id="i_s_ud_box">
+                                        <property name="visible">True</property>
+                                        <child>
+                                           <object class="GtkButton" id="input_source_move_up">
+                                             <property name="visible">True</property>
+                                             <child internal-child="accessible">
+                                               <object class="AtkObject" id="i_s_u_a11y">
+                                                 <property name="accessible-name" translatable="yes">Move Input Source Up</property>
+                                               </object>
+                                             </child>
+                                             <child>
+                                                <object class="GtkImage" id="i_s_u_image">
+
+                                                  <property name="visible">True</property>
+                                                  <property name="icon-name">go-up-symbolic</property>
+                                                  <property name="icon-size">1</property>
+                                                </object>
+                                             </child>
+                                           </object>
+                                        </child>
+                                        <child>
+                                           <object class="GtkButton" id="input_source_move_down">
+                                             <property name="visible">True</property>
+                                             <child internal-child="accessible">
+                                               <object class="AtkObject" id="i_s_d_a11y">
+                                                 <property name="accessible-name" translatable="yes">Move Input Source Down</property>
+                                               </object>
+                                             </child>
+                                             <child>
+                                                <object class="GtkImage" id="i_s_d_image">
+                                                  <property name="visible">True</property>
+                                                  <property name="icon-name">go-down-symbolic</property>
+                                                  <property name="icon-size">1</property>
+                                                </object>
+                                             </child>
+                                           </object>
+                                        </child>
+                                      </object>
+                                    </child>
                                   </object>
-                                  <packing>
-                                    <property name="expand">False</property>
-                                    <property name="homogeneous">True</property>
-                                  </packing>
                                 </child>
+
                                 <child>
-                                  <object class="GtkToolButton" id="xkb_layouts_move_down">
+                                  <object class="GtkSeparatorToolItem" id="sep2">
                                     <property name="visible">True</property>
-                                    <property name="can_focus">False</property>
-                                    <property name="label" translatable="yes">Move Down</property>
-                                    <property name="use_underline">True</property>
-                                    <property name="icon_name">go-down-symbolic</property>
+                                    <property name="draw">False</property>
+                                    <property name="hexpand">True</property>
                                   </object>
                                   <packing>
-                                    <property name="expand">False</property>
-                                    <property name="homogeneous">True</property>
+                                    <property name="expand">True</property>
                                   </packing>
                                 </child>
+
                                 <child>
-                                  <object class="GtkToolButton" id="xkb_layouts_show">
+                                  <object class="GtkToolItem" id="i_s_sp_item">
                                     <property name="visible">True</property>
-                                    <property name="can_focus">False</property>
-                                    <property name="label" translatable="yes">Preview Layout</property>
-                                    <property name="use_underline">True</property>
-                                    <property name="icon_name">input-keyboard-symbolic</property>
+                                    <child>
+                                      <object class="GtkBox" id="i_s_sp_box">
+                                        <property name="visible">True</property>
+                                        <child>
+                                           <object class="GtkButton" id="input_source_settings">
+                                             <property name="visible">True</property>
+                                             <child internal-child="accessible">
+                                               <object class="AtkObject" id="i_s_s_a11y">
+                                                 <property name="accessible-name" translatable="yes">Input Source Settings</property>
+                                               </object>
+                                             </child>
+                                             <child>
+                                                <object class="GtkImage" id="i_s_s_image">
+
+                                                  <property name="visible">True</property>
+                                                  <property name="icon_name">preferences-system-symbolic</property>
+                                                  <property name="icon_size">1</property>
+                                                  <property name="pixel_size">16</property>
+                                                </object>
+                                             </child>
+                                           </object>
+                                        </child>
+                                        <child>
+                                           <object class="GtkButton" id="input_source_show">
+                                             <property name="visible">True</property>
+                                             <child internal-child="accessible">
+                                               <object class="AtkObject" id="i_s_p_a11y">
+                                                 <property name="accessible-name" translatable="yes">Show Keyboard Layout</property>
+                                               </object>
+                                             </child>
+                                             <child>
+                                                <object class="GtkImage" id="i_s_p_image">
+
+                                                  <property name="visible">True</property>
+                                                  <property name="icon_name">input-keyboard-symbolic</property>
+                                                  <property name="icon-size">1</property>
+                                                </object>
+                                             </child>
+                                           </object>
+                                        </child>
+                                      </object>
+                                    </child>
                                   </object>
-                                  <packing>
-                                    <property name="expand">False</property>
-                                    <property name="homogeneous">True</property>
-                                  </packing>
                                 </child>
+
                               </object>
                               <packing>
                                 <property name="expand">False</property>
